unit MainUtDX;

interface

{$R Neto.Res}

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   DDraw, DDUtils, DDCanvas, DXSound1, Module1;

const
   MAX_X_LINE : Word = 640;
   MAX_Y_LINE : Word = 480;

   MAX_IMAGE_SURFACE = 2;
   MAX_AUX_SURFACE   = 1;
   IMAGE_SURFACE     = MAX_IMAGE_SURFACE;
   IMAGE_FILE_NAME   = 'NeTo';

   WIN_MOUSE_X_GAP   = 5;
   WIN_MOUSE_Y_GAP   = 24;

   BPP               : WORD    = 2;

type

   TOption = record
      IsExclusive           : boolean; // Direct X     
      IsHighResolution      : boolean; // ػ  
      CanModifyWalkFrame    : boolean; // ǽð  Ű 
      CanDisplayPerformance : boolean; //  ս   
      UseSystemMemory       : boolean; // ý ޸𸮸 ۷ 
      UseDirectSound        : boolean; // Direct Sound 
	  UseDirectMusic        : boolean; // Direct Music 
	  CanEditMap            : boolean; //     ִ° ?
      LoadFromResource      : boolean; // ҽκ εϴ° ?
      IsRegistered          : boolean; //   Ǿ° ?
   end;

   TPixelFormat = (pfUnknown, pfRGB8, pfRGB16, pfRGB15, pfBGR16, pfRGB24, pfBGR24, pfRGB32);

   TBasic = class(TForm)

      procedure   DDFormCreate  (Sender: TObject);
      procedure   DDFormDestroy (Sender: TObject);
      procedure   DDFormShow    (Sender: TObject; IsExclusive : boolean);

      procedure   FormCreate    (Sender: TObject);
      procedure   FormShow      (Sender: TObject);
      procedure   FormClose     (Sender: TObject; var Action: TCloseAction);
      procedure   FormDestroy   (Sender: TObject);
      procedure   FormMinimize  (Sender: TObject);
      procedure   FormOnRestore (Sender: TObject);
      procedure   FormPaint     (Sender: TObject);
      procedure   FormKeyDown   (Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure   FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

   private

	  FPreviousFlipping : boolean;
      FFlippingEnabled  : boolean;
      FActive           : boolean;
      FIsFirstShow      : boolean;
      FCounter          : integer;

      procedure   ExceptionHandler(Sender  : TObject; Error : Exception);
      procedure   HandleMessage   (var Msg : TMsg; var Handled : boolean);
      procedure   IdleHandler     (Sender  : TObject; var Done : boolean);
      function    GetBitmapName   (BitmapName : string; i : integer) : string;
      function    RestoreSurfaces : HResult;
      procedure   DrawSurfaces;
      procedure   SetFlippingEnabled(Value : boolean);

   public

      FStartTickCount   : integer;              // īƮ ۽ Tick
      FFlippingCount    : integer;              //  ø ȸ

      PressedKey        : Word;

      FIsLocked         : boolean;
      PixelFormat       : TPixelFormat;
      Tranceparency     : DWORD;

      // Direct Draw
      DirectDraw        : IDirectDraw7;         // DirectDraw object  
      PrimarySurface    : IDirectDrawSurface7;  //  ȭ 
      BackBuffer        : IDirectDrawSurface7;  // ĸ 
      Clipper           : IDirectDrawClipper;   // Ŭ ü
      DDPalette         : IDirectDrawPalette;   // ĸ  Ʈʿ ε
      PrimaryCanvas     : TDDCanvas;
      BackCanvas        : TDDCanvas;            // ̹ 
      Image             : array[1..MAX_IMAGE_SURFACE] of IDirectDrawSurface7;
      AuxImage          : array[1..MAX_AUX_SURFACE  ] of IDirectDrawSurface7;
      LockDesc          : TDDSurfaceDesc2;      // Lock Suface Ÿ 

      // Direct Sound
      DirectSound       : TDXSound;

      procedure   DrawScreen;
      procedure   UpdateDisplay(IsCommandable : boolean);
      function    MakeItSo     (DDResult : HResult) : boolean;
      property    FlippingEnabled : boolean read  FFlippingEnabled
                                            write SetFlippingEnabled;
      procedure   LockBackGround;
      procedure   UnlockBackGround;

      procedure   InitializeGame;
      procedure   FinalizeGame;

	  procedure   ProcessMessages;
      procedure   WMActiveApp(var Msg : TWMActivateApp); message WM_ACTIVATEAPP;

   end;

var
   Basic          : TBasic;
   Option         : TOption;
   CommandMessage : (cmNone, cmRoleMode) = cmNone;
   CurrectMode    : (mdTitle, mdRole) = mdTitle;


implementation

{$R *.DFM}

uses
   SbModule;

const
   DD_ERROR_CONST = $88760000;


function    TBasic.GetBitmapName(BitmapName : string; i : integer) : string;
begin
   Result := {ExtractFilePath(Application.ExeName) + }BitmapName + IntToStr(i);// + '.BMP';
end;

procedure   TBasic.DDFormCreate(Sender: TObject);
begin
   FIsFirstShow      := TRUE;

   FIsLocked         := FALSE;
   FPreviousFlipping := FALSE;
   FFlippingEnabled  := FALSE;

   //  ڵ鷯 
   Application.OnException  := ExceptionHandler;
   Application.OnMinimize   := FormMinimize;
   Application.OnRestore    := FormOnRestore;
//   Application.OnActivate   := FormOnRestore;
//   Application.OnDeactivate := FormMinimize;

   Color       := clBlack;

   if Option.IsExclusive then begin
//      SetBounds(0,0,MAX_X_LINE,MAX_Y_LINE);
//      BorderStyle := bsNone;
   end else begin
      SetBounds(0,0,MAX_X_LINE+WIN_MOUSE_X_GAP*2,MAX_Y_LINE+WIN_MOUSE_Y_GAP+5);
      BorderStyle := bsSingle;
   end;
end;

procedure   TBasic.DDFormShow(Sender: TObject; IsExclusive : boolean);
var
   i             : integer;
   Test          : HRESULT;
//   pVideo        : PDWORD;
   DirectDrawOld : IDirectDraw;
   DDSurfaceDesc : TDDSurfaceDesc2;
   DDSCaps       : TDDSCaps2;
   DDPixelFormat : TDDPixelFormat;
   ColorKey      : TDDColorKey;
   DC            : HDC;
begin
   if not FIsFirstShow then exit;

   FIsFirstShow := FALSE;

  { DD COM ü  }
   if DirectDrawCreate(nil,DirectDrawOld,nil) <> DD_OK then
      Raise Exception.Create('DirectDraw ü  ');

   if DirectDrawOld.QueryInterface(IDirectDraw4,DirectDraw) <> DD_OK then
      Raise Exception.Create('DirectDraw7 ü  ');

   DirectDrawOld._Release;
   Pointer(DirectDrawOld) := nil;

   if not Assigned(DirectDraw) then exit;

   if IsExclusive then begin

     { Ÿ Ǯũ Ȯ }
      Test := DirectDraw.SetCooperativeLevel(Handle,DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN or DDSCL_ALLOWREBOOT);
      if Test <> DD_OK then
         Raise Exception.Create('Ÿ Ǯũ   : '+IntToStr(Test-DD_ERROR_CONST));

     { ȭ  ٲ }
      Test := DirectDraw.SetDisplayMode(MAX_X_LINE,MAX_Y_LINE,8*BPP,0,0);
      if Test <> DD_OK then
         Raise Exception.Create('640 x 480   : '+IntToStr(Test-DD_ERROR_CONST));

     { DirectDrawSurface ũ  }
      FillChar(DDSurfaceDesc,SizeOf(DDSurfaceDesc),0);
      with DDSurfaceDesc do begin
         dwSize            := SizeOf(DDSurfaceDesc);
         dwFlags           := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
         ddSCaps.dwCaps    := DDSCAPS_COMPLEX or DDSCAPS_FLIP or DDSCAPS_PRIMARYSURFACE;
         if Option.UseSystemMemory then
            ddSCaps.dwCaps := ddSCaps.dwCaps or DDSCAPS_SYSTEMMEMORY;
		 dwBackBufferCount := 1;
      end;

     {  ȭ   }
      Test := DirectDraw.CreateSurface(DDSurfaceDesc,PrimarySurface,nil);
      if Test <> DD_OK then
         Raise Exception.Create(' ȭ    : '+IntToStr(Test-DD_ERROR_CONST));

     { ĸ  ü  }
      DDSCaps.dwCaps := DDSCAPS_BACKBUFFER;
      Test := PrimarySurface.GetAttachedSurface(DDSCaps,BackBuffer);
      if Test <> DD_OK then
         Raise Exception.Create('ĸ    : '+IntToStr(Test-DD_ERROR_CONST));

   end else begin

     { Ϲ   }
      if DirectDraw.SetCooperativeLevel(Handle,DDSCL_NORMAL) <> DD_OK then
         Raise Exception.Create('Ϲ    ');

     { DirectDrawSurface ũ  }
      FillChar(DDSurfaceDesc,SizeOf(DDSurfaceDesc),0);
      with DDSurfaceDesc do begin
         dwSize            := SizeOf(DDSurfaceDesc);
         dwFlags           := DDSD_CAPS;
         ddSCaps.dwCaps    := DDSCAPS_PRIMARYSURFACE;
      end;

     {  ȭ   }
      if DirectDraw.CreateSurface(DDSurfaceDesc,PrimarySurface,nil) <> DD_OK then
         Raise Exception.Create(' ȭ   ');

     { ĸ  ü  }
      FillChar(DDSurfaceDesc,SizeOf(DDSurfaceDesc),0);
      with DDSurfaceDesc do begin
         dwSize            := SizeOf(DDSurfaceDesc);
         dwFlags           := DDSD_CAPS or DDSD_HEIGHT or DDSD_WIDTH;
         ddSCaps.dwCaps    := DDSCAPS_OFFSCREENPLAIN;
         if Option.UseSystemMemory then
            ddSCaps.dwCaps := ddSCaps.dwCaps or DDSCAPS_SYSTEMMEMORY;
         dwWidth           := MAX_X_LINE;
         dwHeight          := MAX_Y_LINE;
      end;

      if DirectDraw.CreateSurface(DDSurfaceDesc,BackBuffer,nil) <> DD_OK then
         Raise Exception.Create('   ');

      if DirectDraw.CreateClipper(0,Clipper,nil) <> DD_OK then
         Raise EXception.Create('Ŭ ü  ');

      if Clipper.SetHWnd(0,handle) <> DD_OK then
		 Raise EXception.Create('Ŭ ü  ');

      if PrimarySurface.SetClipper(Clipper) <> DD_OK then
         Raise EXception.Create('Ŭ ǥ ߰ ');

      try
         BackBuffer.GetDC(DC);
         BPP := GetDeviceCaps(DC,BITSPIXEL) div 8;
      finally
         BackBuffer.ReleaseDC(DC);
      end;
   end;

  {  ȭ  TDDCanvases ü  }
   PrimaryCanvas  := TDDCanvas.Create(PrimarySurface);
   BackCanvas     := TDDCanvas.Create(BackBuffer);

  { ĵ ʱȭ }
   with Basic.BackCanvas do try
      Font.Name   := 'Default';
      Font.Size   := 12;
      Font.Color  := clWhite;
      Font.Style  := [{fsBold,fsItalic}];
      Brush.Style := bsClear;
//      Brush.Style := bsSolid;
//      Brush.Color := RGB(90,40,180);
      Pen.Color   := RGB(0,255,100);
   finally
      release;
   end;

  { ȷƮ ε }
   if (BPP = 1) and IsExclusive then begin
      DDPalette := DDLoadPalette(DirectDraw,GetBitmapName(IMAGE_FILE_NAME,1));
      if PrimarySurface.SetPalette(DDPalette) <> DD_OK then
         Raise Exception.Create('ȷƮ ε ');
   end;

  { Ʈ  & ε }
   for i := 1 to IMAGE_SURFACE do begin
      Image[i] := DDLoadBitmap(DirectDraw,GetBitmapName(IMAGE_FILE_NAME,i),0,0,Option.UseSystemMemory);
   end;

  {   }
   for i := 1 to IMAGE_SURFACE do begin
      ColorKey.dwColorSpaceLowValue  := 0;
      ColorKey.dwColorSpaceHighValue := 0;
      if Image[i].SetColorKey(DDCKEY_SRCBLT,@ColorKey) <> DD_OK then
         Raise Exception.Create('  ');
   end;

  { ȼ  ǵ }

   FillChar(DDPixelFormat,sizeof(DDPixelFormat),0);
   DDPixelFormat.dwSize := sizeof(DDPixelFormat);
   if PrimarySurface.GetPixelFormat(DDPixelFormat) <> DD_OK then
      Raise Exception.Create('ȼ  б ');

   case BPP of

      1 :
      begin
         PixelFormat := pfRGB8;
      end;

      2 :
      begin
         if DDPixelFormat.dwRBitMask = $0000F800 then begin
            PixelFormat   := pfRGB16;
            Tranceparency := $FFFF;
         end else if DDPixelFormat.dwRBitMask = $00007C00 then begin
            PixelFormat   := pfRGB15;
            Tranceparency := $7FFF;
         end else if DDPixelFormat.dwRBitMask = $0000001F then begin
            PixelFormat   := pfBGR16;
            Tranceparency := $FFFF;
         end else begin
            PixelFormat   := pfUnknown;
            Tranceparency := $0000;
         end;
         SbModule.SetWriteMode(PixelFormat);
      end;

      3 :
      begin
         if DDPixelFormat.dwRBitMask = $00FF0000 then begin
            PixelFormat   := pfRGB24;
            Tranceparency := $FFFFFF;
         end else if DDPixelFormat.dwRBitMask = $000000FF then begin
            PixelFormat   := pfBGR24;
            Tranceparency := $FFFFFF;
         end else begin
            PixelFormat   := pfUnknown;
            Tranceparency := $000000;
         end;
      end;

      4 :
      begin
         PixelFormat   := pfRGB32;
         Tranceparency := $FFFFFF;
      end;

      else
      begin
         PixelFormat   := pfUnknown;
      end;

   end;

   Cursor := crNone;
   if Option.IsExclusive then begin
      ShowCursor(FALSE);
   end;

   InitializeGame;

end;

procedure   TBasic.DDFormDestroy(Sender: TObject);
var
   i : integer;
begin
   UnlockBackGround;
  {  ø  }
   FlippingEnabled := FALSE;

   FinalizeGame;

  { ĵ ü  }
   PrimaryCanvas.Free;
   BackCanvas.Free;

  { ȭ   }
   if Assigned(PrimarySurface) then begin
      PrimarySurface._Release;
      Pointer(PrimarySurface) := nil;
   end;

   if Option.IsExclusive then begin
      Pointer(BackBuffer) := nil;
   end else begin
      if Assigned(BackBuffer) then begin
         BackBuffer._Release;
         Pointer(BackBuffer) := nil;
      end;
   end;

   for i := 1 to IMAGE_SURFACE do begin
      if Assigned(Image[i]) then begin
         Image[i]._Release;
         Pointer(Image[i]) := nil;
      end;
   end;

  { DirectDraw COM ü  }
   if Assigned(DirectDraw) then begin
      DirectDraw._Release;
      Pointer(DirectDraw) := nil;
   end;

  {  ڵ鷯  }
   Application.OnException  := nil;
   Application.OnMinimize   := nil;
   Application.OnRestore    := nil;
   Application.OnActivate   := nil;
   Application.OnDeactivate := nil;

   ShowCursor(TRUE);
end;

procedure   TBasic.LockBackGround;
begin
   if not FIsLocked then begin
      LockDesc.dwSize := SizeOf(TDDSurfaceDesc);
      repeat
      until MakeItSo(BackBuffer.Lock(PRect(nil),LockDesc,DDLOCK_SURFACEMEMORYPTR +
                     DDLOCK_WAIT, 0));
      FIsLocked := TRUE;
   end;
end;

procedure   TBasic.UnlockBackGround;
begin
   if FIsLocked then begin
      BackBuffer.UnLock(LockDesc.lpSurface);
      FIsLocked := FALSE;
   end;
end;

procedure   TBasic.SetFlippingEnabled(Value : boolean);
begin
   if Value <> FFlippingEnabled then begin
      FFlippingEnabled := Value;
      if FFlippingEnabled then begin
        {  ̺Ʈ ڵ鷯 ġ }
//         Application.OnMessage := HandleMessage;
         Application.OnIdle    := IdleHandler;
      end else begin
        {  ̺Ʈ ڵ鷯  }
         Application.OnMessage := nil;
         Application.OnIdle    := nil;
      end;
   end;
end;

function    TBasic.MakeItSo(DDResult : HResult) : boolean;
begin
  { ȭ   Լ }
   case DDResult of
      DD_OK             : Result := TRUE;
      DDERR_SURFACELOST : Result := RestoreSurfaces <> DD_OK;
      else                Result := DDResult <> DDERR_WASSTILLDRAWING;
   end;
end;

function   TBasic.RestoreSurfaces : HResult;
var
   i : integer;
begin
  { ȭ Ҿ MakeItSo ȣ }
   Result := PrimarySurface._Restore;
   if Result = DD_OK then begin
      for i := 1 to IMAGE_SURFACE do begin
         Result := Image[i]._Restore;
         if Result <> DD_OK then begin
            exit;
         end;
      end;
      if Result = DD_OK then DrawSurfaces;
   end;
end;

procedure   TBasic.DrawSurfaces;
var
   i : integer;
begin
   for i := 1 to IMAGE_SURFACE do begin
      DDReloadBitmap(Image[i],GetBitmapName(IMAGE_FILE_NAME,i));
   end;
end;

procedure   TBasic.UpdateDisplay(IsCommandable : boolean);
begin
   if FActive or not Option.IsExclusive then DrawScreen;
end;

procedure   TBasic.HandleMessage(var Msg : TMsg; var Handled : boolean);
begin
   UpdateDisplay(TRUE);
end;

procedure   TBasic.IdleHandler(Sender : TObject; var Done : boolean);
begin
   UpdateDisplay(TRUE);
   Done := FALSE;
end;

(* WINDOW EVENT SECTION *)

procedure   TBasic.FormCreate(Sender: TObject);
begin

   if Option.IsHighResolution then begin
      MAX_X_LINE         := 800;
      MAX_Y_LINE         := 600;
   end else begin
      MAX_X_LINE         := 640;
      MAX_Y_LINE         := 480;
   end;

   FActive  := TRUE;
   FCounter := 1000;

   if Option.UseDirectSound then begin
      DirectSound := TDXSound.Create(Handle);
      if Option.LoadFromResource then begin
         DirectSound.LoadWaveResource(hInstance,'Walk',MakeIntResource(25),FALSE);
      end else begin
         DirectSound.LoadWave('Walk.Wav',FALSE);
      end;
   end;

   DDFormCreate(Sender);

end;

procedure   TBasic.FormShow(Sender: TObject);
begin
   DDFormShow(Sender,Option.IsExclusive);
end;

procedure   TBasic.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   BorderStyle := bsSingle;
end;

procedure   TBasic.FormDestroy(Sender: TObject);
begin
   DDFormDestroy(Sender);

   if Assigned(DirectSound) then begin
      DirectSound.Free;
      DirectSound := nil;
   end;
end;

procedure   TBasic.FormPaint(Sender: TObject);
begin
   if Assigned(DirectDraw) then
      DrawSurfaces;
end;

procedure   TBasic.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if Key = VK_F12 then Close;
   PressedKey := Key;
end;

procedure TBasic.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button = mbLeft  then PressedKey := VK_LBUTTON;
   if Button = mbRight then PressedKey := VK_RBUTTON;
end;

procedure   TBasic.FormMinimize(Sender: TObject);
begin
   FPreviousFlipping := FlippingEnabled;
   FlippingEnabled   := FALSE;
   WindowState       := wsMinimized;
end;

procedure   TBasic.FormOnRestore(Sender: TObject);
begin
   WindowState       := wsNormal;
   FlippingEnabled   := FPreviousFlipping;
   Basic.WindowState := wsNormal;
end;

procedure   TBasic.ExceptionHandler(Sender : TObject; Error : Exception);
var
   WasEnabled : boolean;
   WasLocked  : boolean;
begin
  {  ޼ ̱  GDI ȯ }

   MessageBeep(0);

   WasEnabled      := FlippingEnabled;
   FlippingEnabled := FALSE;

   WasLocked       := FIsLocked;
   if WasLocked then begin
      UnlockBackGround;
   end;

   if Assigned(DirectDraw) then DirectDraw.FlipToGDISurface;

   MessageDlg(Error.Message,mtError,[mbOK],0);

   if WasLocked then begin
      LockBackGround;
   end;

   FlippingEnabled := WasEnabled;

   Close;
end;

procedure   TBasic.ProcessMessages;
begin
   Application.ProcessMessages;
end;

procedure   TBasic.WMActiveApp(var Msg : TWMActivateApp);
begin
   FActive := Msg.Active;
   if FActive then begin
      FFlippingCount  := -50;
      FStartTickCount := GetTickCount;
      FlippingEnabled := TRUE;
   end else begin
      if Option.IsExclusive then begin
         FlippingEnabled := FALSE;
      end;
   end;

end;

(* USER DEFINIION SECTION *)

procedure   TBasic.InitializeGame;
var
   Temp : Longint;
begin
   SystemParametersInfo(SPI_SCREENSAVERRUNNING,Word(TRUE),@Temp,0); // Disabled Ctrl-Alt-Del
   case CurrectMode of
	  mdTitle : begin end;
	  mdRole  : Module1.InitializeGame;
   end;
end;

procedure   TBasic.FinalizeGame;
var
   Temp : Longint;
begin
   case CurrectMode of
	  mdTitle : begin end;
	  mdRole  : Module1.FinalizeGame;
   end;
   ClipCursor(nil);
   SystemParametersInfo(SPI_SCREENSAVERRUNNING,Word(FALSE),@Temp,0); // Enabled Ctrl-Alt-Del
end;

procedure   TBasic.DrawScreen;
var
   Msg : string;
begin
//   DirectMusic.TimeProcedure(Msg);
   case CurrectMode of
      mdTitle : begin end;
      mdRole  : Module1.DoAction;
   end;

   if CommandMessage <> cmNone then begin
      case CommandMessage of
         cmRoleMode :
         begin
            FinalizeGame;
            CurrectMode := mdRole;
            InitializeGame;
         end;
      end;
      CommandMessage := cmNone;
   end;

   Inc(FCounter);
end;

begin
   with Option do begin
	  IsExclusive           := TRUE;
	  IsHighResolution      := not TRUE;
	  CanModifyWalkFrame    := not TRUE;
	  CanDisplayPerformance := TRUE;
	  UseSystemMemory       := TRUE;
	  UseDirectSound        := not TRUE;
	  UseDirectMusic        := not TRUE;
	  CanEditMap            := TRUE;
	  IsRegistered          := not TRUE;
	  LoadFromResource      := TRUE;
   end;
   CurrectMode := mdRole;
end.

