unit Module1;

{$DEFINE _FOG_EFFECT}

interface

uses
   Windows,  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   ExtCtrls, mmSystem,
{$IFNDEF VER100}
   Math,
{$ENDIF}
   DDraw,    DDUtils,  DDCanvas, SrchPath;

const

   MAX_MAP_X           = 100;
   MAX_MAP_Y           = 100;

   MAX_CHARA_IMAGE     = 5;
   MAX_PERSON          = 4;
   MAX_OBJECT          = 100;
   AVAILABLE_PERSON    = MAX_PERSON;
   MAX_MONOLOGUE       = 4;

   MAX_FACE_COUNT_SUB  : integer = 1;//2;
   PERSON_FRAME        = 3;
   PERSON_DIRECTION    = 4;
   PERSON_ALL_FRAME    = PERSON_FRAME * PERSON_DIRECTION;
   PERSON_ADD_NUMBER   = 100;

   WALK_FRAME          : integer = 3;//6 MAX_FACE_COUNT_SUB * PERSON_FRAME;
   JUMP_ACCEL          = 20;
   JUMP_DECEL          = 4;

   MAX_BITMAP_TILE     = 4*6;

   TILE_IMAGE_BMP      = 1;
   CHARACTER_IMAGE_BMP = 2;

type

   EFace         = (efLEFT, efDOWN, efUP, efRIGHT);
   TDisplayMeans = (dmNormal, dmBright, dmEffect, dmAddEffect, dmBlueEffect, dmGreenEffect, dmRedEffect);
   TMapAttribute = (maTile,maHeight,maPerson,maReveal,maShow);
   TMapData      = array[0..Pred(MAX_MAP_Y),0..Pred(MAX_MAP_X),TMapAttribute] of byte;

   SetOfPerson   = set of 1..MAX_PERSON;

   // ȭ  ü
   TMap = class

      constructor Create(FileName : String);
	  constructor CreateResource(Instance : HINST; ResName : String; ResType : PChar);

   private
      mMapData    : TMapData;
      mCurrentMap : string;

      procedure   MakeRandomMap;
      function    ReadMap(attribute : TMapAttribute; x, y : integer) : byte;
      procedure   WriteMap(attribute : TMapAttribute; x, y : integer; value : byte);

   public
      function    IsMovableMap(_x, _y, x, y : integer) : boolean;
      function    IsMovableMapWithJump(_x, _y, x, y  : integer; var Jump : integer) : boolean;
      function    IsMovableMapWithPerson(_x, _y, x, y, Person : integer) : boolean;

      procedure   ClearShowMap;
      procedure   SetShowMap(x, y, Range : integer);

      function    LoadMap(s : string) : boolean;
      function    LoadMapResource(Instance : HINST; ResName : String; ResType : PChar) : boolean;
      procedure   SaveMap;
      function    GetLogicalPosition(Physical : TPoint) : TPoint;
                    //  ȭ鿡 µǴ ȼ ġ  ʻ  ǥ ˾Ƴ.
      Function    GetPhysicalPosition(Logical : TPoint) : TPoint;
                    // ʻ  ǥ ȭ鿡 ǥõǴ ȼ » ġ ˾ .

      property    Map[attribute : TMapAttribute; x, y : integer] : byte read ReadMap write WriteMap;
   end;

   //    ڽ ǥ   ִ ü
   TTile = class

      constructor Create(Number : integer; ARect : TRect);
      procedure   DisplaySelf(Pos : TPoint); virtual;
      procedure   DisplaySelfMesh(Pos : TPoint); virtual;
      procedure   DisplaySelfTrans(Pos : TPoint; IsHalf : Boolean); virtual;

   public
      mXLen, mYLen : word;
      mSprite      : record Number : integer; Range : TRect end;

   end;

   // ġ  ü
   TSprite = class(TTile)

      constructor Create(Number : integer; Origin : Integer);
	  function    ReturnCharaTile : integer; virtual; abstract;
      function    DoAction : boolean; virtual;

   private
      m_number, m_origin  : integer;
      m_x, m_y, m_z       : integer;

   public
      property    mNumber : integer read m_number write m_number;
      property    mOrigin : integer read m_origin write m_origin;
      property    mX      : integer read m_x      write m_x;
      property    mY      : integer read m_y      write m_y;
      property    mZ      : integer read m_z      write m_z;
   end;

   // ġ ̵  Ҹ   ü
   TMirage = class(TSprite)

      constructor Create(Number : integer; Origin : integer; DisplayMeans : TDisplayMeans);

   private
      mDisplayMeans : TDisplayMeans;
      mExtinction   : Integer;
      mStep         : Integer;
      mMoveDir      : TPoint;
      mMoveStep     : Integer;
      mEffectRate   : Integer;

   public

      procedure   Initialize(MoveDir : TPoint; Step : Integer; Extinction : Integer);
      function    ReturnCharaTile : integer; override;
      procedure   DisplaySelf(Pos : TPoint); override;
      function    DoAction : boolean; override;

   end;

   // ĳ ü
   TPerson = class(TSprite)

      constructor Create(Number, Origin, Frame : integer);

   private
      m_face        : EFace;
      m_old_face    : EFace;
      m_face_count  : integer;
      m_face_inc    : integer;
	  m_max_frame   : integer;
      m_CanControl  : Boolean;
      m_AutoScript  : String;
      m_halt_count  : integer;

      m_mono_count  : DWORD;
      m_monologue   : array[1..MAX_MONOLOGUE] of record
                         Script : String[50];
                         Color  : TColorRef;
                      end;

      function    GetInJumping : Boolean;

   public
      mFaceIncSub   : integer;
      mInMoving     : boolean;
      mMoveStep     : integer;
      mMoveDir      : TPoint;
      mBrightness   : integer;
      mTransparency : integer;
      mDodgeRate    : integer;
      mJump         : integer;
      mJumpAccel    : integer;
      mJumpPower    : integer;
      mJumpDec      : integer;
      mHaveShadow   : Boolean;

      procedure   MoveXY(x1, y1 : integer);
      procedure   MoveXYAuto;
      procedure   WarpXY(x, y : integer);
      procedure   Jump(Accel : integer);
      function    ReturnCharaTile : integer; override;
      function    ReturnCharaRect : TRect;
      function    GetRealWalkFrame : integer;

      procedure   DisplaySelf(Pos : TPoint); override;
      procedure   DisplaySelfMesh(Pos : TPoint); override;
      procedure   SetFace(Direction : TPoint);
      procedure   IncFaceStep;
      procedure   UpdateFace;

      procedure   ClearMonologue;
      procedure   SetMonologueTime(mS : integer);
      procedure   AddMonologue(Script : String; Color : TColorRef);
      function    GetMonologue(Number : integer) : String;
      procedure   DisplayMonologue(x, y : integer);

	  function    DoAction   : boolean; override;

      property    mFace      : EFace    read m_face       write m_face;
      property    mOldFace   : EFace    read m_old_face   write m_old_face;
      property    mFaceCount : integer  read m_face_count write m_face_count;
      property    mFaceInc   : integer  read m_face_inc   write m_face_inc;

      property    mCanControl : Boolean read m_CanControl write m_CanControl;
      property    mAutoScript : String  read m_AutoScript write m_AutoScript;
      property    mInJumping  : Boolean read GetInJumping;
   end;

   TDisplayState = (dsLogical, dsAbsolute);

   TChara        = record
      Image : integer;
      Rect  : TRect;
   end;

   TSystem = class

      constructor Create;

   private
      m_DisplayState  : TDisplayState;

      procedure SetDisplayState(State  : TDisplayState);

   public
      AbsoluteParam   : record
         mX, mY, dX, dY : integer;
      end;

      SelectedPerson  : SetOfPerson;
      MAIN_CHARACTER  : integer;  //  ΰ ĳ ȣ
      Counter         : integer;  // ѹ øɶ 1 
      MouseStep       : integer;  // 콺 Ŀ 
      LatestSelection : integer;  //   Ÿ 
      CurrentMapAxis  : TPoint;

      // ڵ  
      FixCursorPos    : Boolean;
      FixedCursorPos  : TPoint;
      FixedPitchPos   : TPoint;
      FixedOnPerson   : Byte;

      ButtonPressed   : Boolean;
	  DragStartPos    : TPoint;

      Map             : TMap;
      Tile            : array[0..Pred(MAX_BITMAP_TILE)] of TTile;
      Chara           : array[1..MAX_CHARA_IMAGE,0..PERSON_ALL_FRAME*MAX_PERSON] of TChara;
      Person          : array[1..MAX_PERSON] of TPerson;
      Objects         : array[1..MAX_OBJECT] of TSprite;

      procedure   ChangeCharacter;
      procedure   PlaySoundWithPan(Number : integer; Pos : TPoint);
      procedure   DrawQuaterView;

      property    DisplayState : TDisplayState read m_DisplayState write SetDisplayState;
   end;

var
   GameSystem  : TSystem;


function    InRect(ARect : TRect; APoint : TPoint) : Boolean;
function    GetAsyncKeyStateEx(vKey : integer) : Smallint;
function    SearchPathEx(Person : integer; Destination, Pitch : TPoint) : boolean;
procedure   InitializeGame;
procedure   FinalizeGame;
procedure   DoAction;
procedure   DisplayCursor;
procedure   DisplayMap(ShowCursor, CanFlip : boolean);


implementation

uses
   MainUtDX, SbModule;

const

   TILE_X_SIZE   = 60;
   TILE_X_HALF   = TILE_X_SIZE div 2;
   TILE_Y_SIZE   = 51;
   TILE_Y_HALF   = 14;
   TILE_Y_HEIGHT = 13;

(* ... TMap Methods Definition ... *)

constructor TMap.Create(FileName : String);
begin
   inherited Create;
   if not LoadMap(FileName) then MakeRandomMap;
end;

constructor TMap.CreateResource(Instance : HINST; ResName : String; ResType : PChar);
begin
   inherited Create;
   if not LoadMapResource(Instance,ResName,ResType) then MakeRandomMap;
end;

procedure   TMap.MakeRandomMap;
var
   i, j, k : integer;
begin
   Randomize;
   for j := 0 to Pred(MAX_MAP_Y) do begin
      for i := 0 to Pred(MAX_MAP_X) do begin
         case Random(100) of
             0..80 : k := 3;
            81..92 : k := 2;
            93..96 : k := 1;
            97..99 : k := 0;
            else     k := 0;
         end;
         mMapData[j][i][maTile] := k;
         if Random(100) < 5 then k := 4 else k := 0;
         mMapData[j][i][maHeight] := Random(k+1);
         mMapData[j][i][maPerson] := 0;
      end;
   end;
end;

function  TMap.ReadMap(attribute : TMapAttribute; x, y : integer) : byte;

 function  IsUnvalancedMap(x, y : integer; height : byte) : boolean;
 begin
    IsUnvalancedMap := FALSE;
    if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
       if ReadMap(maHeight,x,y) <> height then IsUnvalancedMap := TRUE;
    end;
 end;

var
   tile_no : byte;
begin
   if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
      if attribute = maTile then begin
         tile_no := mMapData[y][x][maTile] * 4;
		 if IsUnvalancedMap(x,y-1,ReadMap(maHeight,x,y)) then Inc(tile_no,1);
         if IsUnvalancedMap(x+1,y,ReadMap(maHeight,x,y)) then Inc(tile_no,2);
      end else if attribute in [maHeight,maPerson,maReveal,maShow] then begin
         tile_no := mMapData[y][x][attribute];
      end else tile_no := 0;
   end else tile_no := 0;
   ReadMap := tile_no;
end;

procedure TMap.WriteMap(attribute : TMapAttribute; x, y : integer; value : byte);
begin
   if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
      mMapData[y][x][attribute] := value;
   end;
end;

function  TMap.IsMovableMap(_x, _y, x, y : integer) : boolean;
begin
   if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
      if (Map[maHeight,_x,_y]+1 >= Map[maHeight,x,y]) and
         not (Map[maPerson,x,y] in [1..MAX_PERSON,PERSON_ADD_NUMBER+1..PERSON_ADD_NUMBER+MAX_PERSON]) then
         IsMovableMap := TRUE
      else
         IsMovableMap := FALSE;
   end else
      IsMovableMap := FALSE;
end;

function  TMap.IsMovableMapWithJump(_x, _y, x, y  : integer; var Jump : integer) : boolean;
begin
   if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
      if (Map[maHeight,_x,_y]+(Jump div TILE_Y_HEIGHT) >= Map[maHeight,x,y]) and
         not (Map[maPerson,x,y] in [1..MAX_PERSON,PERSON_ADD_NUMBER+1..PERSON_ADD_NUMBER+MAX_PERSON]) then begin
         IsMovableMapWithJump := TRUE;
         if (Map[maHeight,x,y] <> Map[maHeight,_x,_y]) then begin
            Jump := Jump - (Map[maHeight,x,y] - Map[maHeight,_x,_y]) * TILE_Y_HEIGHT;
         end;
      end else begin
         IsMovableMapWithJump := FALSE;
      end;
   end else begin
      IsMovableMapWithJump := FALSE;
   end;   
end;

function  TMap.IsMovableMapWithPerson(_x, _y, x, y, Person : integer) : boolean;
begin
   if (x >= 0) and (y >= 0) and (x < MAX_MAP_X) and (y < MAX_MAP_Y) then begin
      if (Map[maHeight,_x,_y]+1 >= Map[maHeight,x,y]) and
         not (Map[maPerson,x,y] in ([1..MAX_PERSON,PERSON_ADD_NUMBER+1..PERSON_ADD_NUMBER+MAX_PERSON]-[Person,Person+PERSON_ADD_NUMBER])) then
         IsMovableMapWithPerson := TRUE
      else
         IsMovableMapWithPerson := FALSE;
   end else
      IsMovableMapWithPerson := FALSE;
end;

procedure   TMap.ClearShowMap;
var
   i, j : integer;
begin
   for j := 0 to Pred(MAX_MAP_Y) do begin
      for i := 0 to Pred(MAX_MAP_X) do begin
         Map[maShow,i,j] := 0;
      end;
   end;
end;

procedure   TMap.SetShowMap(x, y, Range : integer);
var
   i, j   : integer;
   Bright : integer;
begin
{
   for j := 0 to Pred(MAX_MAP_Y) do begin
      for i := 0 to Pred(MAX_MAP_X) do begin
         if (Abs(i-x) <= Range) and (Abs(j-y) <= Range) then begin
            Map[maShow,i,j] := 1;
            Map[maReveal,i,j] := 1;
         end else begin
            Map[maShow,i,j] := 0;
         end;
      end;
   end;
}
   Bright := Round(Range * Range * 0.7);
   Range  := Range * Range - 5;
   for j := 0 to Pred(MAX_MAP_Y) do begin
      for i := 0 to Pred(MAX_MAP_X) do begin
         if (Sqr(Abs(i-x)) + Sqr(Abs(j-y))) <= Bright then begin
            Map[maShow,i,j] := 2;
            Map[maReveal,i,j] := 1;
         end else
         if (Sqr(Abs(i-x)) + Sqr(Abs(j-y))) <= Range then begin
			if Map[maShow,i,j] < 1 then Map[maShow,i,j] := 1;
            Map[maReveal,i,j] := 1;
         end else begin
//            Map[maShow,i,j] := 0;
         end;
      end;
   end;
end;

function    TMap.LoadMap(s : string) : boolean;
var
   f       : File;
   i, j, k : integer;
begin
   LoadMap := FALSE;

   AssignFile(f,s);
 {$I-}
   Reset(f,1);
 {$I+}

   if IOResult = 0 then begin
      BlockRead(f,mMapData[0,0,maTile],sizeof(mMapData));

      for k := 1 to MAX_PERSON do
      for j := 0 to Pred(MAX_MAP_Y) do begin
         for i := 0 to Pred(MAX_MAP_X) do begin
            if Map[maPerson,i,j] = GameSystem.Person[k].mNumber then begin
               GameSystem.Person[k].mX := i;
               GameSystem.Person[k].mY := j;
            end;
         end;
      end;

      mCurrentMap := s;
      LoadMap     := TRUE;
   end;
end;

function    TMap.LoadMapResource(Instance : HINST; ResName : String; ResType : PChar) : boolean;
var
   f        : File;
   i, j, k  : integer;
   Resource : TResourceStream;
begin
   LoadMapResource := FALSE;

   Resource := TResourceStream.Create(Instance,ResName,ResType);

   if Assigned(Resource) then begin
      Resource.Read(mMapData[0,0,maTile],sizeof(mMapData));

      for k := 1 to MAX_PERSON do
      for j := 0 to Pred(MAX_MAP_Y) do begin
         for i := 0 to Pred(MAX_MAP_X) do begin
            if Map[maPerson,i,j] = GameSystem.Person[k].mNumber then begin
               GameSystem.Person[k].mX := i;
               GameSystem.Person[k].mY := j;
            end;
         end;
      end;

      mCurrentMap     := ResName + '.DAT';
      LoadMapResource := TRUE;

      Resource.Free;
   end;
end;

procedure   TMap.SaveMap;
var
   f : File;
begin
   AssignFile(f,mCurrentMap);
   Rewrite(f,1);
   BlockWrite(f,mMapData[0,0,maTile],sizeof(mMapData));
   CloseFile(f);
end;

function    TMap.GetLogicalPosition(Physical : TPoint) : TPoint;
const
   GRAD = TILE_Y_HALF / TILE_X_HALF;
var
   i, j : integer;
   x, y : integer;
begin
   Physical.X := Physical.X - TILE_X_HALF * 0;
   Physical.Y := Physical.Y + TILE_Y_HALF * 1 + 2;

   i := (Physical.X + TILE_X_HALF) div (TILE_X_HALF * 2);
   j := (Physical.Y + TILE_Y_HALF) div (TILE_Y_HALF * 2);

   x := (i - j) + GameSystem.CurrentMapAxis.X;
   y := (i + j) + GameSystem.CurrentMapAxis.Y;

   i := (Physical.X + TILE_X_HALF) mod (TILE_X_HALF * 2);
   j := (Physical.Y + TILE_Y_HALF) mod (TILE_Y_HALF * 2);

   if GRAD * i + j < TILE_Y_HALF   then Dec(y);
   if GRAD * i + j > TILE_Y_HALF*3 then Inc(y);
   if GRAD * i - j > TILE_Y_HALF   then Inc(x);
   if GRAD * i - j < -TILE_Y_HALF  then Dec(x);

   if Option.IsHighResolution then begin
      GetLogicalPosition := Point(x-7,y+1);
   end else begin
      GetLogicalPosition := Point(x-6,y+1);
   end;
end;

function    TMap.GetPhysicalPosition(Logical : TPoint) : TPoint;
var
   i, j : integer;
   x, y : integer;
begin
   if Option.IsHighResolution then begin
      x := Logical.X - GameSystem.CurrentMapAxis.X + 7;
      y := Logical.Y - GameSystem.CurrentMapAxis.Y - 1;
   end else begin
      x := Logical.X - GameSystem.CurrentMapAxis.X + 6;
      y := Logical.Y - GameSystem.CurrentMapAxis.Y - 1;
   end;

   i := Pred(x + y) * TILE_X_HALF + TILE_X_HALF * 0;
   j := Pred(y - x) * TILE_Y_HALF - TILE_Y_HALF * 1 - 2;

   GetPhysicalPosition := Point(i,j);
end;

(* ... TTile Methods Definition ... *)

constructor TTile.Create(Number : integer; ARect : TRect);
begin
   inherited Create;

   mXLen          := Succ(ARect.Right - ARect.Left);
   mYLen          := Succ(ARect.Bottom - ARect.Top);
   mSprite.Number := Number;
   mSprite.Range  := ARect;
end;

procedure   TTile.DisplaySelf(Pos : TPoint);
begin
   PutSprite(Pos.X,Pos.Y,mSprite.Number,mSprite.Range,smCentered);
end;

procedure   TTile.DisplaySelfMesh(Pos : TPoint);
begin
   PutSpriteMesh(Pos.X,Pos.Y,mSprite.Number,mSprite.Range,smCentered,0);
end;

procedure   TTile.DisplaySelfTrans(Pos : TPoint; IsHalf : Boolean);
begin
   if IsHalf then
//	  PutSprite(Pos.X,Pos.Y,mSprite.Number+1,mSprite.Range,smCentered)
	  PutSpriteTrans(Pos.X,Pos.Y,mSprite.Number,mSprite.Range,smCentered)
   else
      PutSpriteTrans75(Pos.X,Pos.Y,mSprite.Number,mSprite.Range,smCentered)
end;

(* ... TSprite Methods Definition ... *)

constructor TSprite.Create(Number : integer; Origin : integer);
begin
   mNumber := number;
   mOrigin := Origin;
end;

function    TSprite.DoAction : boolean;
begin
   DoAction := TRUE;
end;

(* ... TMirage Methods Definition ... *)

constructor TMirage.Create(Number : integer; Origin : integer; DisplayMeans : TDisplayMeans);
begin
   Inherited Create(Number,Origin);
   mDisplayMeans := DisplayMeans;
   mExtinction   := 0;
   mStep         := 0;
   mMoveDir      := Point(0,0);
   mMoveStep     := 0;
   mEffectRate   := 100;
end;

procedure   TMirage.Initialize(MoveDir : TPoint; Step : Integer; Extinction : Integer);
begin
   mMoveDir      := MoveDir;
   mStep         := Step;
   mExtinction   := Extinction;
end;

function    TMirage.ReturnCharaTile : integer;
begin
   ReturnCharaTile := 1;
end;

procedure   TMirage.DisplaySelf(Pos : TPoint);
var
   Chara : TChara;
begin
   Chara := GameSystem.Chara[mOrigin,ReturnCharaTile];
   ModifyEdge(Pos.x,Pos.y,Chara.Rect,smCentered);
   case mDisplayMeans of
      dmNormal      : PutSprite(Pos.X,Pos.Y,Chara.Image,Chara.Rect,smCentered);
      dmBright      : PutBrightImage(Pos.x,Pos.y,Chara.Rect,Basic.Image[Chara.Image],Basic.BackBuffer,mEffectRate);
      dmEffect      : PutEffect(Pos.X,Pos.Y,Chara.Rect,Basic.Image[Chara.Image],Basic.BackBuffer,Round(mEffectRate*1.28),ceNone);
{
      dmAddEffect   :
      dmBlueEffect  :
      dmGreenEffect :
      dmRedEffect   :
}
   end;


end;

function    TMirage.DoAction : boolean;
begin
   DoAction := TRUE;
end;

(* ... TPerson Methods Definition ... *)

constructor TPerson.Create(Number, Origin, Frame : integer);
begin
   inherited Create(Number,Origin);

   mX            := 0;
   mY            := 0;
   mFace         := EFace(0);
   mFaceCount    := 0;
   mFaceInc      := 1;
   mFaceIncSub   := 0;
   m_max_frame   := Frame;
   m_halt_count  := 0;
   mBrightness   := 0;
   mTransparency := 100;
   mDodgeRate    := 100;
   mJump         := 0;
   mJumpAccel    := 0;
   mJumpPower    := JUMP_ACCEL;
   mJumpDec      := JUMP_DECEL;
   mHaveShadow   := TRUE;

   ClearMonologue;

   mXLen         := 54;
   mYLen         := 70;

   mCanControl   := TRUE;
end;

function    TPerson.ReturnCharaTile : integer;
begin
   case m_max_frame of
      1 :
      begin
         ReturnCharaTile := 0;
      end;
      PERSON_ALL_FRAME :
      begin
         if m_halt_count > 1 then mFaceCount := 1;
         if mJump > 0        then mFaceCount := 1;
         ReturnCharaTile := integer(mFace)*PERSON_FRAME+mFaceCount;
      end;
      else
         ReturnCharaTile := 0;
//   ReturnCharaTile := Pred(mOrigin)*PERSON_ALL_FRAME+integer(mFace)*PERSON_FRAME+mFaceCount;
   end;
end;

function    TPerson.ReturnCharaRect : TRect;
var
   Axis : TPoint;
begin
   Axis := GameSystem.Map.GetPhysicalPosition(Point(mX,mY));
   Axis.X := Axis.X - GameSystem.AbsoluteParam.dX;
   Axis.Y := Axis.Y - GameSystem.AbsoluteParam.dY;
   ReturnCharaRect := Bounds(Axis.X+11,Axis.Y-40,39,60);
end;

function    TPerson.GetRealWalkFrame : integer;
begin
   if mMoveDir.X * mMoveDir.Y =  1 then begin
	  GetRealWalkFrame := WALK_FRAME * 2;
   end else begin
	  GetRealWalkFrame := WALK_FRAME;
   end;
end;

{ $DEFINE VIEW_CHARACTER_RECT}

procedure   TPerson.DisplaySelf(Pos : TPoint);
var
   Chara : TChara;
   Rate  : integer;
{$IFDEF VIEW_CHARACTER_RECT}
   ARect : TRect;
{$ENDIF}
begin

   Basic.UnlockBackGround;

   // ׸
   if mHaveShadow then begin
      if mInMoving then Rate := -30
                   else Rate := -50;
      PutEffect(Pos.X-14,Pos.Y-17,Bounds(250,40,27,13),Basic.Image[TILE_IMAGE_BMP],Basic.BackBuffer,Rate,ceAdd);
   end;

{$IFDEF VIEW_CHARACTER_RECT}
   try
      ARect := ReturnCharaRect;
      Basic.BackCanvas.Brush.Style := bsClear;
      Basic.BackCanvas.Pen.Color   := RGB(0,0,255);
      Basic.BackCanvas.Rectangle(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
   finally
      Basic.BackCanvas.Release;
   end;
{$ENDIF}

   Pos.y := Pos.y - mJump;
   Chara := GameSystem.Chara[mOrigin,ReturnCharaTile];
   if mDodgeRate = 100 then begin
      if mTransparency = 100 then begin
         //   
         if mBrightness <> 0 then begin;
            //  ̰  
            ModifyEdge(Pos.x,Pos.y,Chara.Rect,smCentered);
            PutBrightImage(Pos.x,Pos.y,Chara.Rect,Basic.Image[Chara.Image],Basic.BackBuffer,mBrightness);
         end else begin
            // Ϲ Ʈ
            PutSprite(Pos.X,Pos.Y,Chara.Image,Chara.Rect,smCentered);
         end;
      end else begin
         //  ߰Ǵ Ʈ
         ModifyEdge(Pos.x,Pos.y,Chara.Rect,smCentered);
		 PutEffect(Pos.X,Pos.Y,Chara.Rect,Basic.Image[Chara.Image],Basic.BackBuffer,mTransparency,ceAdd);
      end;
   end else begin
      //  ִ Ʈ
      ModifyEdge(Pos.x,Pos.y,Chara.Rect,smCentered);
      PutEffect(Pos.X,Pos.Y,Chara.Rect,Basic.Image[Chara.Image],Basic.BackBuffer,Round(mDodgeRate*1.28),ceNone);
   end;
end;

procedure   TPerson.DisplaySelfMesh(Pos : TPoint);
var
   Chara : TChara;
begin
   //   ޽  ʴ´
   if mTransparency <> 100 then Exit;
   if mDodgeRate    <> 100 then Exit;

   Pos.y := Pos.y - mJump;
   Chara := GameSystem.Chara[mOrigin,ReturnCharaTile];
   PutSpriteMesh(Pos.X,Pos.Y,Chara.Image,Chara.Rect,smCentered,mBrightness);
end;

function    TPerson.GetInJumping : Boolean;
begin
   GetInJumping := (mJump > 0) or (mJumpAccel > 0);
end;

procedure   TPerson.MoveXY(x1, y1 : integer);
var
   FaceCount : integer;
   Face      : EFace;
begin
   if mInMoving then exit;
   if (mX+x1 < 0) or (mY+y1 < 0) or (mX+x1 >= MAX_MAP_X) or (mY+y1 >= MAX_MAP_Y) then exit;

   //      ⸸ ٲ.
   Face := mFace;
   SetFace(Point(x1,y1));
   if Face <> mFace then Exit;

   FaceCount := mFaceCount;
   mMoveDir  := Point(0,0);

   if mJump = 0 then
      GameSystem.PlaySoundWithPan(1,Point(mX,mY));

   with GameSystem do begin

      if Map.IsMovableMapWithJump(mX,mY,mX+x1,mY+y1,mJump) or
         ((not mInJumping) and (Map.IsMovableMap(mX,mY,mX+x1,mY+y1))) then begin
         // 4   
         if x1 * y1 = 0 then begin
            mMoveDir := Point(x1,y1);
         end else begin
            // 8       ȵȴ.
            if Map.IsMovableMap(mX,mY,mX,mY+y1) and Map.IsMovableMap(mX,mY,mX+x1,mY) then begin
               mMoveDir := Point(x1,y1);
            end;
         end;
      end;

(*    ڵ Ѱ ý ( Jump ý    )
      if (mMoveDir.x = 0) and (mMoveDir.y = 0) then begin
         //  ϰ    ʴ´
         if not mInJumping then begin
            if Map.Map[maPerson,mX+x1,mY+y1] in [1..MAX_PERSON,PERSON_ADD_NUMBER+1..PERSON_ADD_NUMBER+MAX_PERSON] then begin
//               Person[Map.Map[maPerson,mX+x1,mY+y1]].talkSomeone(mFace);
//               exit;
            end;
            if x1 = 0 then begin
               if y1 < 0 then begin
                  if Map.IsMovableMap(mX,mY,mX+1,mY) and Map.IsMovableMap(mX,mY,mX+1,mY-1) then begin
                     mMoveDir := Point(+1,0);
                  end else if Map.IsMovableMap(mX,mY,mX-1,mY) and Map.IsMovableMap(mX,mY,mX-1,mY-1) then begin
                     mMoveDir := Point(-1,0);
                  end;
               end else begin
                  if Map.IsMovableMap(mX,mY,mX-1,mY) and Map.IsMovableMap(mX,mY,mX-1,mY+1) then begin
                     mMoveDir := Point(-1,0);
                  end else if Map.IsMovableMap(mX,mY,mX+1,mY) and Map.IsMovableMap(mX,mY,mX+1,mY+1) then begin
                     mMoveDir := Point(+1,0);
                  end;
               end;
            end else
            if y1 = 0 then begin
               if x1 < 0 then begin
                  if Map.IsMovableMap(mX,mY,mX,mY-1) and Map.IsMovableMap(mX,mY,mX-1,mY-1) then begin
                     mMoveDir := Point(0,-1);
                  end else if Map.IsMovableMap(mX,mY,mX,mY+1) and Map.IsMovableMap(mX,mY,mX-1,mY+1) then begin
                     mMoveDir := Point(0, 1);
                  end;
               end else begin
                  if Map.IsMovableMap(mX,mY,mX,mY+1) and Map.IsMovableMap(mX,mY,mX+1,mY+1) then begin
					 mMoveDir := Point(0, 1);
                  end else if Map.IsMovableMap(mX,mY,mX,mY-1) and Map.IsMovableMap(mX,mY,mX+1,mY-1) then begin
                     mMoveDir := Point(0,-1);
                  end;
               end;
            end else
            if (x1 = -1) and (y1 = -1) then begin // '4'
               if      Map.IsMovableMap(mX,mY,mX-1,mY) then mMoveDir := Point(-1,0)
               else if Map.IsMovableMap(mX,mY,mX,mY-1) then mMoveDir := Point(0,-1)
            end else
            if (x1 = -1) and (y1 =  1) then begin // '2'
               if      Map.IsMovableMap(mX,mY,mX-1,mY) then mMoveDir := Point(-1,0)
               else if Map.IsMovableMap(mX,mY,mX,mY+1) then mMoveDir := Point(0,+1)
            end else
            if (x1 =  1) and (y1 = -1) then begin // '8'
               if      Map.IsMovableMap(mX,mY,mX+1,mY) then mMoveDir := Point(+1,0)
               else if Map.IsMovableMap(mX,mY,mX,mY-1) then mMoveDir := Point(0,-1)
            end else
            if (x1 =  1) and (y1 =  1) then begin // '6'
               if      Map.IsMovableMap(mX,mY,mX+1,mY) then mMoveDir := Point(+1,0)
               else if Map.IsMovableMap(mX,mY,mX,mY+1) then mMoveDir := Point(0,+1)
            end;
         end else begin
            mFaceCount := FaceCount;
            Exit;
         end;
      end;
*)
      if (mMoveDir.X <> 0) or (mMoveDir.Y <> 0) then begin
         SetFace(mMoveDir);
         GameSystem.Map.Map[maPerson,mX+mMoveDir.X,mY+mMoveDir.Y] := mNumber + PERSON_ADD_NUMBER;
         mMoveStep := 0;
         mInMoving := TRUE;
         MoveXYAuto;
      end else begin
         SetFace(Point(x1,y1));
      end;

   end;

end;

procedure   TPerson.MoveXYAuto;
begin
   if not mInMoving then exit;

   m_halt_count := 0;

   inc(mMoveStep);
   IncFaceStep;

   if mNumber = GameSystem.MAIN_CHARACTER then begin
      if LoByte(GetAsyncKeyStateEx(VK_CONTROL)) > 0 then Jump(mJumpPower);
   end;

   if ((mMoveDir.X * mMoveDir.Y =  1) and (mMoveStep >= WALK_FRAME * 2)) or
      ((mMoveDir.X * mMoveDir.Y <> 1) and (mMoveStep >= WALK_FRAME)) then begin
      GameSystem.Map.Map[maPerson,mX,mY] := 0;
      mX        := mX + mMoveDir.X;
      mY        := mY + mMoveDir.Y;
      GameSystem.Map.Map[maPerson,mX,mY] := mNumber;
      mInMoving := FALSE;
      mMoveDir  := Point(0,0);
   end;

   if (mMoveDir.X * mMoveDir.Y =  1) and (mMoveStep = WALK_FRAME) then begin
      if mJump = 0 then
         GameSystem.PlaySoundWithPan(1,Point(mX,mY));
   end;
end;

procedure   TPerson.WarpXY(x, y : integer);
begin
   if (x < 0) or (y < 0) or (x >= MAX_MAP_X) or (y >= MAX_MAP_Y) then exit;
   if (mX >= 0) and (mY >= 0) and (mX < MAX_MAP_X) and (mY < MAX_MAP_Y) then begin
      if GameSystem.Map.Map[maPerson,mX,mY] = 0 then begin
         GameSystem.Map.Map[maPerson,mX,mY] := 0;
      end;
   end;
   mX := x; mY := y;
   GameSystem.Map.Map[maPerson,mX,mY] := mNumber;
end;

procedure   TPerson.Jump(Accel : integer);
begin
   mJumpAccel := Accel;
end;

procedure   TPerson.SetFace(Direction : TPoint);
begin
   if Direction.Y < 0 then mFace := efUP;
   if Direction.Y > 0 then mFace := efDOWN;
   if Direction.X < 0 then mFace := efLEFT;
   if Direction.X > 0 then mFace := efRIGHT;
end;

procedure TPerson.IncFaceStep;
begin
   inc(mFaceIncSub);

   if mFaceIncSub >= MAX_FACE_COUNT_SUB then begin
      mFaceCount := mFaceCount + mFaceInc;
      if mFaceInc > 0 then begin
         if mFaceCount >= PERSON_FRAME then mFaceCount := 0;
      end else begin
         if mFaceCount < 0 then mFaceCount := Pred(PERSON_FRAME);
      end;
      mFaceIncSub := 0;
   end;
end;

procedure   TPerson.UpdateFace;
begin
   mFace := mOldFace;
end;

procedure   TPerson.ClearMonologue;
begin
   FillChar(m_monologue,Sizeof(m_monologue),0);
   m_mono_count := 0;
end;

procedure   TPerson.SetMonologueTime(mS : integer);
begin
   m_mono_count := timeGetTime + mS;
end;

procedure   TPerson.AddMonologue(Script : String; Color : TColorRef);
var
   i : integer;
begin
   for i := 1 to MAX_MONOLOGUE do begin
      if m_monologue[i].Script = '' then begin
         m_monologue[i].Script := Script;
         m_monologue[i].Color  := Color;
         Break;
      end;
   end;
end;

function    TPerson.GetMonologue(Number : integer) : String;
begin
   if Number in [1..MAX_MONOLOGUE] then begin
      GetMonologue := m_monologue[Number].Script;
   end;
end;

procedure   TPerson.DisplayMonologue(x, y : integer);
var
   i : integer;
begin
   if m_monologue[1].Script = '' then Exit;
   try
      for i :=  1 to MAX_MONOLOGUE do begin
         if m_monologue[i].Script <> '' then begin
            Basic.BackCanvas.Font.Color := clBlack;
            Basic.BackCanvas.TextOut(x+1,y+Pred(i)*16+1,m_monologue[i].Script);
            Basic.BackCanvas.Font.Color := m_monologue[i].Color;
            Basic.BackCanvas.TextOut(x,y+Pred(i)*16,m_monologue[i].Script);
         end else begin
            Break;
         end;
      end;
   finally
      Basic.BackCanvas.Release;
   end;

   // ȥڸ ...
   if m_mono_count <= timeGetTime then ClearMonologue;
end;

function    TPerson.DoAction : boolean;

 function  Sign(value : integer) : integer;
 begin
    if      value > 0 then Sign := 1
    else if value < 0 then Sign := -1
    else                   Sign := 0;
 end;

var
   x1, y1   : integer;
begin

{$IFDEF _FOG_EFFECT}
   Gamesystem.Map.SetShowMap(mX,mY,7);
{$ENDIF}

   DoAction := TRUE;

   // Jump κ ó
   if mInJumping then begin
      mJump := mJump + mJumpAccel;
      Dec(mJumpAccel,mJumpDec);
      if mJump <= 0 then begin
         mJump      := 0;
         mJumpAccel := 0;
      end;
   end;

   if mInMoving then begin
      MoveXYAuto;
      exit;
   end;

   if not mCanControl then begin
      if (LoByte(GetAsyncKeyStateEx(VK_ESCAPE )) = 0) and
         (LoByte(GetAsyncKeyStateEx(VK_RBUTTON)) = 0) then begin
         if Length(mAutoScript) > 0 then begin
            case mAutoScript[1] of
               '8' : moveXY( 1, 0);
               '2' : moveXY(-1, 0);
               '4' : moveXY( 0,-1);
               '6' : moveXY( 0, 1);
               // 밢 
               '7' : moveXY( 1,-1);
               '1' : moveXY(-1,-1);
               '3' : moveXY(-1, 1);
               '9' : moveXY( 1, 1);
            end;
         end else begin
            mCanControl              := TRUE;
            GameSystem.FixCursorPos  := FALSE;
            GameSystem.FixedOnPerson := 0;
         end;
		 mAutoScript := Copy(mAutoScript,2,Pred(Length(mAutoScript)));

         if mNumber = GameSystem.MAIN_CHARACTER then begin
            if LoByte(GetAsyncKeyStateEx(VK_CONTROL)) > 0 then Jump(mJumpPower);
         end;
      end else begin
         mAutoScript              := '';
		 mCanControl              := TRUE;
         GameSystem.FixCursorPos  := FALSE;
         GameSystem.FixedOnPerson := 0;
	  end;
      exit;
   end;

   if mNumber = GameSystem.MAIN_CHARACTER then begin
      if (HiByte(GetAsyncKeyStateEx(VK_NUMPAD9)) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_PRIOR  )) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY( 1, 0);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_NUMPAD1)) > 0) or
		 (HiByte(GetAsyncKeyStateEx(VK_END    )) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY(-1, 0);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_NUMPAD7)) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_HOME   )) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY( 0,-1);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_NUMPAD3)) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_NEXT   )) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY( 0, 1);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_UP     )) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_NUMPAD8)) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY( 1,-1);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_RIGHT  )) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_NUMPAD6)) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY( 1, 1);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_DOWN   )) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_NUMPAD2)) > 0) then begin
		 GameSystem.DisplayState := dsLogical;
         moveXY(-1, 1);
      end;
      if (HiByte(GetAsyncKeyStateEx(VK_LEFT   )) > 0) or
         (HiByte(GetAsyncKeyStateEx(VK_NUMPAD4)) > 0) then begin
         GameSystem.DisplayState := dsLogical;
         moveXY(-1,-1);
	  end;

      if LoByte(GetAsyncKeyStateEx(VK_CONTROL)) > 0 then Jump(mJumpPower);

      if LoByte(GetAsyncKeyStateEx(VK_ESCAPE)) > 0 then Basic.Close;
      if LoByte(GetAsyncKeyStateEx(VK_INSERT)) > 0 then GameSystem.ChangeCharacter;

   end else begin
	  if mNumber = 2 then begin
{
		 x1 := GameSystem.Person[GameSystem.MAIN_CHARACTER].mX - mX;
		 y1 := GameSystem.Person[GameSystem.MAIN_CHARACTER].mY - mY;
		 if (Abs(x1) > 1) or (Abs(y1) > 1) then begin
			MoveXY(Sign(x1),Sign(y1));
		 end else begin
			ClearMonologue;
			AddMonologue('ȭ ȫ̿',RGB(255,150,200));
			AddMonologue('޵  ϶',RGB(250,150,255));
			SetMonologueTime(1000);
		 end;
}
		if Random(100) = 0 then begin
			ClearMonologue;
			AddMonologue('ȭ ȫ̿',RGB(255,150,200));
			AddMonologue('޵  ϶',RGB(250,150,255));
			SetMonologueTime(1000);
		end;
      end else begin
         if Random(100) = 0 then begin
            x1 := Pred(Random(2)*2);
            y1 := Pred(Random(2)*2);
            if (x1 <> 0) and (y1 <> 0) then begin
               if Random(2) = 0 then x1 := 0 else y1 := 0;
            end;
            MoveXY(x1,y1);
         end;
      end;
   end;

   if not mInMoving then Inc(m_halt_count);
end;

(* ... TSystem Methods Definition ... *)

constructor TSystem.Create;
begin
   inherited Create;

   Counter         := 0;
   MouseStep       := 0;
   MAIN_CHARACTER  := 1;
   LatestSelection := 0;
   DisplayState    := dsLogical;
   ButtonPressed   := FALSE;
end;

procedure   TSystem.PlaySoundWithPan(Number : integer; Pos : TPoint);
var
   APoint    : TPoint;
   i         : integer;
begin
   if Option.UseDirectSound then begin
      APoint := GameSystem.Map.GetPhysicalPosition(Pos);
      i := (APoint.X+15) - 320;
      if i < -256 then i := -256;
      if i >  256 then i :=  256;
      Basic.DirectSound.Pan[Number] := i;
      Basic.DirectSound.Play(Number);
   end;
end;

procedure   TSystem.DrawQuaterView;
type
   TMeshCharacter = record
      Pos    : TPoint;
      Number : integer;
   end;
const
   MAX_MESH = 100;
var
   X_BOUNDARY                : integer;
   MAP_SQ_WIDE, Pos          : TPoint;
   x, y, z, i, j, rX, rY     : integer;
   _number, _height, _person : byte;
   _isShow                   : byte;
   x_axis,  y_axis,  x_wide  : integer;
   map_x, map_y              : integer;
   dX, dY, aX, aY            : integer;
   WalkFrame                 : integer;
   // ޽  κ
   CharacterCount            : integer;
   MeshCharacter             : array[1..MAX_MESH] of TMeshCharacter;
begin

//   Basic.UnlockBackGround;
{$IFDEF _FOG_EFFECT}
   DDClearDevice(Basic.BackBuffer,0);
{$ENDIF}

   CharacterCount := 0;
   X_BOUNDARY     := (MAX_X_LINE-TILE_X_HALF) - (MAX_X_LINE-TILE_X_HALF) mod TILE_X_HALF;

   if GameSystem.DisplayState = dsLogical then begin
	  with Person[MAIN_CHARACTER] do begin
		 WalkFrame := GetRealWalkFrame;
		 map_x     := mX;
		 map_y     := mY;
		 dX        := ( mMoveDir.X + mMoveDir.Y) * TILE_X_HALF * mMoveStep div WalkFrame;
		 dY        := (-mMoveDir.X + mMoveDir.Y) * TILE_Y_HALF * mMoveStep div WalkFrame;
	  end;
   end else begin
	  map_x := GameSystem.AbsoluteParam.mX;
	  map_y := GameSystem.AbsoluteParam.mY;
	  dX    := GameSystem.AbsoluteParam.dX;
	  dY    := GameSystem.AbsoluteParam.dY;
   end;

{$IFDEF _FOG_EFFECT}
   Map.SetShowMap(Person[MAIN_CHARACTER].mX,Person[MAIN_CHARACTER].mY,7);
{$ENDIF}

   if Option.IsHighResolution then begin
	  MAP_SQ_WIDE := Point(8,24);
      Inc(map_x,12); Inc(map_y,5);
   end else begin
      MAP_SQ_WIDE := Point(7,20);
      Inc(map_x,10); Inc(map_y,4);
   end;

   CurrentMapAxis := Point(map_x,map_y - MAP_SQ_WIDE.Y);

   rX := -MAP_SQ_WIDE.X+1;
   rY := -MAP_SQ_WIDE.Y;
   for j := -MAP_SQ_WIDE.Y to MAP_SQ_WIDE.Y do begin
      if odd(j) then begin
         x_axis := - TILE_X_HALF;
         inc(rY);
      end else begin
         x_axis := - TILE_X_HALF * 2;
         dec(rX);
      end;
      y_axis := + TILE_Y_HALF * (j+MAP_SQ_WIDE.Y) + TILE_Y_HALF;
      x := rX;
	  y := rY;

      for i := -MAP_SQ_WIDE.X to MAP_SQ_WIDE.X do begin
         _number := Map.Map[maTile  ,map_x+x,map_y+y];
         _height := Map.Map[maHeight,map_x+x,map_y+y];
         _person := Map.Map[maPerson,map_x+x,map_y+y];
      {$IFDEF _FOG_EFFECT}
         _isShow := Map.Map[maShow  ,map_x+x,map_y+y];
      {$ELSE}
		 _isShow := 2;
	  {$ENDIF}
		 if _isShow = 0 then begin
            if Map.Map[maReveal,map_x+x,map_y+y] = 0 then begin
               inc(x_axis,TILE_X_SIZE);
               inc(x); inc(y);
			   Continue;
            end;
         end;

         for z := 0 to _height do begin
            if (_number div 4) <> 4 then begin
               if _isShow = 2 then
                  Tile[_number].DisplaySelf(Point(x_axis-dX,y_axis-dY-z*TILE_Y_HEIGHT))
               else
				  Tile[_number].DisplaySelfTrans(Point(x_axis-dX,y_axis-dY-z*TILE_Y_HEIGHT),_isShow = 0)
			end else begin
               if _isShow > 0 then
                  Tile[_number].DisplaySelf(Point(x_axis-dX,y_axis-dY+TILE_Y_HEIGHT-z*TILE_Y_HEIGHT))
               else
				  Tile[_number].DisplaySelfTrans(Point(x_axis-dX,y_axis-dY+TILE_Y_HEIGHT-z*TILE_Y_HEIGHT),_isShow = 0)
            end;
         end;

         if _isShow = 0 then begin
            inc(x_axis,TILE_X_SIZE);
            inc(x); inc(y);
            Continue;
         end;

         if _person in [1..MAX_PERSON] then begin
            with Person[_person] do begin
                  WalkFrame := GetRealWalkFrame;

                  aX := ( mMoveDir.X + mMoveDir.Y) * TILE_X_HALF * mMoveStep div WalkFrame;
                  aY := (-mMoveDir.X + mMoveDir.Y) * TILE_Y_HALF * mMoveStep div WalkFrame;
                  Pos.X := x_axis-dX+aX;
                  Pos.Y := y_axis-Map.Map[maHeight,Map_X+x+mMoveDir.X,Map_Y+y+mMoveDir.Y]*TILE_Y_HEIGHT-20-dY+aY;

                  DisplaySelf(Pos);

                  inc(CharacterCount);
                  if CharacterCount <= MAX_MESH then begin
                     MeshCharacter[CharacterCount].Pos    := Pos;
                     MeshCharacter[CharacterCount].Number := _person;
                  end;
            end;
         end;

         if (_person) in [PERSON_ADD_NUMBER+1..PERSON_ADD_NUMBER+MAX_PERSON] then begin
            //    ʴ´.
            if (Person[_person-PERSON_ADD_NUMBER].mTransparency = 100) and
               (Person[_person-PERSON_ADD_NUMBER].mDodgeRate    = 100) then
            with Person[_person-PERSON_ADD_NUMBER] do begin
                  WalkFrame := GetRealWalkFrame;

                  aX := ( mMoveDir.X + mMoveDir.Y) * TILE_X_HALF * mMoveStep div WalkFrame;
                  aY := (-mMoveDir.X + mMoveDir.Y) * TILE_Y_HALF * mMoveStep div WalkFrame;
                  Pos.X := x_axis-(mMoveDir.X+mMoveDir.Y)*TILE_X_HALF-dX+aX;
                  Pos.Y := y_axis-_height*TILE_Y_HEIGHT-20-(-mMoveDir.X+mMoveDir.Y)*TILE_Y_HALF-dY+aY;

                  DisplaySelf(Pos);

				  inc(CharacterCount);
				  if CharacterCount <= MAX_MESH then begin
                     MeshCharacter[CharacterCount].Pos    := Pos;
                     MeshCharacter[CharacterCount].Number := _person - PERSON_ADD_NUMBER;
                  end;
            end;
         end;

         inc(x_axis,TILE_X_SIZE);
         inc(x); inc(y);
      end;
   end;

   // ޽  
   for i := 1 to CharacterCount do begin
      Person[MeshCharacter[i].Number].DisplaySelfMesh(MeshCharacter[i].Pos);
      MeshCharacter[i].Pos.y := MeshCharacter[i].Pos.y - Person[MeshCharacter[i].Number].mJump;
   end;
   //  ±
   for i := 1 to CharacterCount do begin
      with Person[MeshCharacter[i].Number] do
      if mNumber in GameSystem.SelectedPerson then begin
         PutSprite(MeshCharacter[i].Pos.X+(mXLen div 2)-12,MeshCharacter[i].Pos.Y-mYLen+10,TILE_IMAGE_BMP,Bounds(416+(Random(10))*12,0,12,12),smCentered);
      end;
   end;
   // ȥڸ
   for i := 1 to CharacterCount do begin
      Person[MeshCharacter[i].Number].DisplayMonologue(MeshCharacter[i].Pos.X,MeshCharacter[i].Pos.Y-100);
   end;

end;

procedure   TSystem.SetDisplayState(State  : TDisplayState);
begin
   if State = dsAbsolute then begin
      if m_DisplayState <> dsAbsolute then begin
         if Assigned(Person[MAIN_CHARACTER]) then begin
            GameSystem.AbsoluteParam.mX := Person[MAIN_CHARACTER].mX;
            GameSystem.AbsoluteParam.mY := Person[MAIN_CHARACTER].mY;
            GameSystem.AbsoluteParam.dX := 0;
            GameSystem.AbsoluteParam.dY := 0;
         end;
      end;
   end else
   if State = dsLogical then begin
      if m_DisplayState <> dsLogical then begin
         if Assigned(Person[MAIN_CHARACTER]) then begin
            GameSystem.AbsoluteParam.dX := 0;
			GameSystem.AbsoluteParam.dY := 0;
		 end;
      end;
   end;
   m_DisplayState := State;
end;

procedure   TSystem.ChangeCharacter;
begin
   Inc(MAIN_CHARACTER);
   if MAIN_CHARACTER > MAX_PERSON then MAIN_CHARACTER := 1;
end;

(* ... HerRole Procedures Definition ... *)

procedure IntSwap(var A, B : integer);
var
   C : integer;
begin
   C := A;
   A := B;
   B := C;
end;

function  InRect(ARect : TRect; APoint : TPoint) : Boolean;
begin
   if (APoint.X >= ARect.Left) and (APoint.X <= ARect.Right) and
      (APoint.Y >= ARect.Top)  and (APoint.Y <= ARect.Bottom) then begin
      InRect := TRUE;
   end else begin
      InRect := FALSE;
   end;
end;

function  GetAsyncKeyStateEx(vKey : integer) : Smallint;
begin
   if GetFocus = Basic.Handle then begin
      GetAsyncKeyStateEx := GetAsyncKeyState(vKey);
   end else begin
      GetAsyncKeyStateEx := 0;
   end;
end;

function  SearchPathEx(Person : integer; Destination, Pitch : TPoint) : boolean;
const
   MAX_LOCAL_MAP_X = 50;
   MAX_LOCAL_MAP_Y = 50;
var
   i , j      : integer;
   s          : string;
   Origin     : TPoint;
   SearchPath : TSearchPath;
   TempMap    : array[0..Pred(MAX_LOCAL_MAP_Y),0..Pred(MAX_LOCAL_MAP_X)] of byte;
begin
   SearchPathEx := FALSE;
   if Person in [1..AVAILABLE_PERSON] then begin
      if Assigned(GameSystem.Person[Person]) then begin
         GetAsyncKeyStateEx(VK_ESCAPE );
         GetAsyncKeyStateEx(VK_RBUTTON);

         with GameSystem.Person[Person] do
         if mInMoving then begin
            Origin := Point(mX + mMoveDir.X,mY + mMoveDir.Y);
         end else begin
            Origin := Point(mX,mY);
         end;

         Origin := Point(Origin.X - MAX_LOCAL_MAP_X div 2,
                         Origin.Y - MAX_LOCAL_MAP_Y div 2);

         FillChar(TempMap,sizeof(TempMap),0);
         for j := 0 to Pred(MAX_LOCAL_MAP_Y) do
         for i := 0 to Pred(MAX_LOCAL_MAP_X) do begin
            if not Gamesystem.Map.IsMovableMapWithPerson(MAX_LOCAL_MAP_X div 2+Origin.X,MAX_LOCAL_MAP_Y div 2+Origin.Y,i+Origin.X,j+Origin.Y,Person) then TempMap[j,i] := 1;
         end;
         TempMap[MAX_LOCAL_MAP_X div 2,MAX_LOCAL_MAP_Y div 2] := 0;

         SearchPath  := TSearchPath.Create(MAX_LOCAL_MAP_X,MAX_LOCAL_MAP_Y,TempMap);
         s           := SearchPath.SearchNearest(Point(MAX_LOCAL_MAP_X div 2,MAX_LOCAL_MAP_Y div 2),Point(Destination.X-Origin.X,Destination.Y-Origin.Y));
         SearchPath.Free;

         if s <> '' then begin
            GameSystem.Person[Person].mCanControl := FALSE;
			GameSystem.Person[Person].mAutoScript := s;
            GameSystem.FixCursorPos               := TRUE;
            GameSystem.FixedCursorPos             := Destination;
			GameSystem.FixedPitchPos              := Pitch;
            GameSystem.FixedOnPerson              := Gamesystem.Map.Map[maPerson,Destination.X,Destination.Y];
            SearchPathEx                          := TRUE;
         end;
      end;
   end;
end;

procedure InitializeGame;
var
   i, j, k : integer;
begin

   GameSystem := TSystem.Create;

   for i := 1 to MAX_PERSON do begin
	  GameSystem.Person[i] := TPerson.Create(i,i,PERSON_ALL_FRAME);
   end;

//   GameSystem.Person[1].mBrightness := 40;
   GameSystem.Person[2].mTransparency := 80;
   GameSystem.Person[3].mDodgeRate    := 50;
   GameSystem.Person[4].mBrightness   := 40;
{
   GameSystem.Objects[1] := TMirage.Create(1,1,dmEffect);
   (GameSystem.Objects[1] as TMirage).mEffectRate := 50;
}
   if Option.LoadFromResource then begin
	  GameSystem.Map := TMap.CreateResource(hInstance,'Map',MakeIntResource(27));
   end else begin
	  GameSystem.Map := TMap.Create(ExtractFilePath(Application.ExeName) + 'MAP.DAT');
   end;

   for j := 0 to 5 do begin
	  for i := 0 to 3 do begin
		 GameSystem.Tile[j*4+i] := TTile.Create(TILE_IMAGE_BMP,Bounds(i*60,Succ(45*j)+1,60,45));
	  end;
   end;

   for k := 1 to 3 do begin
	  for j := 0 to Pred(PERSON_DIRECTION) do begin
		 for i := 0 to Pred(PERSON_FRAME) do begin
			with GameSystem.Chara[k][j*PERSON_FRAME+i] do begin
			   Image := CHARACTER_IMAGE_BMP;
			   Rect  := Bounds(165*(k-1)+i*55+1,1+71*j,54,70);
			end;
		 end;
	  end;
   end;

   for k := 4 to 4 do begin
	  for j := 0 to Pred(PERSON_DIRECTION) do begin
		 for i := 0 to Pred(PERSON_FRAME) do begin
			with GameSystem.Chara[k][j*PERSON_FRAME+i] do begin
			   Image := CHARACTER_IMAGE_BMP;
			   if j < 2 then begin
				  Rect  := Bounds(i*55+1,285+71*j,54,70);
			   end else begin
				  Rect  := Bounds(165+i*55+1,285+71*(j-2),54,70);
			   end;
			end;
		 end;
	  end;
   end;

   for k := MAX_CHARA_IMAGE to MAX_CHARA_IMAGE do begin
	  for j := 0 to Pred(PERSON_DIRECTION) do begin
		 for i := 0 to Pred(PERSON_FRAME) do begin
			with GameSystem.Chara[k][j*PERSON_FRAME+i] do begin
			   Image := CHARACTER_IMAGE_BMP;
			   if j < 2 then begin
				  Rect  := Bounds(328+i*55+1,285+71*j,54,70);
			   end else begin
				  Rect  := Bounds(328+164+i*55+1,285+71*(j-2),54,70);
			   end;
			end;
		 end;
	  end;
   end;

   for i := VK_LBUTTON to VK_SCROLL do begin
	  GetAsyncKeyStateEx(i);
   end;

   GameSystem.DisplayState := dsAbsolute;

end;

procedure FinalizeGame;
var
   i  : integer;
begin
   GameSystem.Map.Free;

   for i := 1 to MAX_PERSON do begin
      if Assigned(GameSystem.Person[i]) then begin
         GameSystem.Person[i].Free;
      end;
   end;

   GameSystem.Free;

end;

procedure DoAction;
var
   i : integer;
begin
   DisplayMap(TRUE,FALSE);

{$IFDEF _FOG_EFFECT}
   GameSystem.Map.ClearShowMap;
{$ENDIF}

   for i := 1 to MAX_PERSON do begin
	  if Assigned(GameSystem.Person[i]) then begin
		 GameSystem.Person[i].DoAction;
	  end;
   end;

   for i := 1 to MAX_OBJECT do begin
	  if Assigned(GameSystem.Objects[i]) then begin
		 GameSystem.Objects[i].DoAction;
		 GameSystem.Objects[i].DisplaySelf(Point(200,200));
	  end;
   end;

   FlipPage;

end;

procedure DisplayCursor;
const
   FIX_AXIS   : TPoint = (X : 250+1; Y : 16);
var
   i, z       : integer;
   x, y       : word;
   WalkFrame  : integer;
   Pos, Axis  : TPoint;
   dX,  dY    : integer;
   DC         : hDC;
   IsMoved    : Boolean;
   InRange    : Boolean;
   Persons    : SetOfPerson;
   ARect      : TRect;
   CursorRect : TRect;
begin
   GetCursorPos(Axis);
   if not Option.IsExclusive then begin
	 ScreenToClient(Basic.Handle, Axis);
   end;

   IsMoved := FALSE;
   InRange := TRUE;

   dX := GameSystem.AbsoluteParam.dX;
   dY := GameSystem.AbsoluteParam.dY;

   if not GameSystem.ButtonPressed then begin

      if Axis.X <= 0 then begin
            Dec(GameSystem.AbsoluteParam.dX,TILE_X_HALF);
            InRange := FALSE;
            IsMoved := TRUE;
      end;
      if Axis.X >= Pred(MAX_X_LINE) then begin
            Inc(GameSystem.AbsoluteParam.dX,TILE_X_HALF);
            InRange := FALSE;
            IsMoved := TRUE;
      end;
      if Axis.Y <= 0 then begin
            if InRange then Dec(GameSystem.AbsoluteParam.dY,TILE_Y_HALF*2)
                       else Dec(GameSystem.AbsoluteParam.dY,TILE_Y_HALF);
            IsMoved := TRUE;
      end;
      if Axis.Y >= Pred(MAX_Y_LINE) then begin
            if InRange then Inc(GameSystem.AbsoluteParam.dY,TILE_Y_HALF*2)
                       else Inc(GameSystem.AbsoluteParam.dY,TILE_Y_HALF);
            IsMoved := TRUE;
      end;

      if IsMoved then begin
      // 
      if GameSystem.AbsoluteParam.dX < -TILE_X_HALF then begin
         Dec(GameSystem.AbsoluteParam.mY);
         Dec(GameSystem.AbsoluteParam.mX);
         Inc(GameSystem.AbsoluteParam.dX,TILE_X_HALF*2);
      end;
      if GameSystem.AbsoluteParam.dX >= TILE_X_HALF then begin
         Inc(GameSystem.AbsoluteParam.mY);
         Inc(GameSystem.AbsoluteParam.mX);
         Dec(GameSystem.AbsoluteParam.dX,TILE_X_HALF*2);
      end;
      if GameSystem.AbsoluteParam.dY < -TILE_Y_HALF then begin
         Dec(GameSystem.AbsoluteParam.mY);
         Inc(GameSystem.AbsoluteParam.mX);
         Inc(GameSystem.AbsoluteParam.dY,TILE_Y_HALF*2);
      end;
      if GameSystem.AbsoluteParam.dY >= TILE_Y_HALF then begin
         Inc(GameSystem.AbsoluteParam.mY);
         Dec(GameSystem.AbsoluteParam.mX);
         Dec(GameSystem.AbsoluteParam.dY,TILE_Y_HALF*2);
      end;

         if (HiByte(GetAsyncKeyStateEx(VK_UP     )) = 0) and
            (HiByte(GetAsyncKeyStateEx(VK_DOWN   )) = 0) and
            (HiByte(GetAsyncKeyStateEx(VK_LEFT   )) = 0) and
            (HiByte(GetAsyncKeyStateEx(VK_RIGHT  )) = 0) then begin
            GameSystem.DisplayState := dsAbsolute;
//            GameSystem.putSprite(x,y,1,Bounds(GameSystem.MouseStep*18,0,18,18),smLeftTop);
            exit;
         end;
      end;
   end;

   GameSystem.MouseStep := (GameSystem.MouseStep + 1) mod 2;
   x       := Axis.X;
   y       := Axis.Y;
   Pos     := GameSystem.Map.GetLogicalPosition(Point(x+dx,y+dy));
   Axis    := GameSystem.Map.GetPhysicalPosition(Pos);
   z       := GameSystem.Map.Map[maHeight,Pos.X,Pos.Y];

   if LoByte(GetAsyncKeyStateEx(VK_RBUTTON)) > 0 then begin
      for i := 1 to MAX_PERSON do begin
         if i in GameSystem.SelectedPerson then begin
            SearchPathEx(i,Pos,Point(x-Axis.X,y-Axis.Y));
         end;
      end;
   end;

   //    κ
   if Option.CanEditMap then begin
{
      if HiByte(GetAsyncKeyStateEx(VK_LBUTTON)) > 0 then begin
         GameSystem.Map.Map[maTile,Pos.X,Pos.Y] := GameSystem.LatestSelection;
      end;
}
      for i := ord('1') to ord('6') do begin
         if HiByte(GetAsyncKeyStateEx(i)) > 0 then begin
            GameSystem.LatestSelection             := (i - ord('0') + 9) mod 10;
            GameSystem.Map.Map[maTile,Pos.X,Pos.Y] := GameSystem.LatestSelection;
         end;
      end;

      if LoByte(GetAsyncKeyStateEx(VK_ADD)) > 0 then begin
         if GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] < 9 then
            GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] := GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] + 1;
      end;

      if LoByte(GetAsyncKeyStateEx(VK_SUBTRACT)) > 0 then begin
         if GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] > 0 then
            GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] := GameSystem.Map.Map[maHeight,Pos.X,Pos.Y] - 1;
      end;
{
      if HiByte(GetAsyncKeyStateEx(VK_LBUTTON)) > 0 then begin
         if GameSystem.Map.Map[maPerson,Pos.X,Pos.Y] in [1..AVAILABLE_PERSON] then
            GameSystem.MAIN_CHARACTER := GameSystem.Map.Map[maPerson,Pos.X,Pos.Y];
      end;
}
   end;

   if HiByte(GetAsyncKeyStateEx(VK_LBUTTON)) > 0 then begin
      if GameSystem.ButtonPressed then begin
         try
            Basic.BackCanvas.Rectangle(GameSystem.DragStartPos.X,GameSystem.DragStartPos.Y,x,y);
         finally
            Basic.BackCanvas.Release;
         end;
      end else begin
         GameSystem.ButtonPressed := TRUE;
         GameSystem.DragStartPos  := Point(x,y);
      end;
   end else begin
      if GameSystem.ButtonPressed then begin
         CursorRect := Rect(GameSystem.DragStartPos.X,GameSystem.DragStartPos.Y,x,y);
         if CursorRect.Left > CursorRect.Right then IntSwap(CursorRect.Left,CursorRect.Right);
         if CursorRect.Top > CursorRect.Bottom then IntSwap(CursorRect.Top,CursorRect.Bottom);
         Persons := [];
         for i := 1 to MAX_PERSON do begin
            ARect := Gamesystem.Person[i].ReturnCharaRect;
            if InRect(CursorRect,Point(ARect.Left ,ARect.Top)) or
               InRect(CursorRect,Point(ARect.Left ,ARect.Bottom)) or
               InRect(CursorRect,Point(ARect.Right,ARect.Top)) or
               InRect(CursorRect,Point(ARect.Right,ARect.Bottom)) or
               InRect(ARect,Point(CursorRect.Left ,CursorRect.Top)) or
               InRect(ARect,Point(CursorRect.Left ,CursorRect.Bottom)) or
               InRect(ARect,Point(CursorRect.Right,CursorRect.Top)) or
               InRect(ARect,Point(CursorRect.Right,CursorRect.Bottom)) then begin
               Persons := Persons + [i];
            end;
         end;
         //  õǾٸ
         if Persons <> [] then begin
			GameSystem.SelectedPerson := Persons;
         end;
         GameSystem.ButtonPressed := FALSE;
      end;
   end;

   if not GameSystem.ButtonPressed then
   if z > 0 then begin
      PutSprite(Axis.X-dX-2,Axis.Y-dY                +3,TILE_IMAGE_BMP,Bounds(FIX_AXIS.X+100,FIX_AXIS.Y+0,64,23),smLeftTop);
      PutSprite(Axis.X-dX-2,Axis.Y-dY-z*TILE_Y_HEIGHT+3,TILE_IMAGE_BMP,Bounds(FIX_AXIS.X+ 36,FIX_AXIS.Y+0,64,23),smLeftTop);
   end else begin
      PutSprite(Axis.X-dX-2,Axis.Y-dY+3,TILE_IMAGE_BMP,Bounds(FIX_AXIS.X+36,FIX_AXIS.Y+0,64,23),smLeftTop);
   end;

   PutSprite(x,y,TILE_IMAGE_BMP,Bounds(FIX_AXIS.X+GameSystem.MouseStep*18,FIX_AXIS.Y+0,18,18),smLeftTop);
end;

procedure DisplayMap(ShowCursor, CanFlip : boolean);
begin
   Inc(GameSystem.Counter);
   GameSystem.DrawQuaterView;

   if ShowCursor then DisplayCursor;

   if CanFlip then FlipPage;
end;

end.

